<?php
/**
 * @package Real Estate
 * @copyright  OrdaSoft
 * @author  Andrey Kvasnevskiy-OrdaSoft(akbet@mail.ru)
 * @description Search Real Estate for Real Estate Component
 * Homepage: https://ordasoft.com/joomla-real-estate
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
*/

defined( '_JEXEC' ) or die( 'Restricted access' );


$doc = JFactory::getDocument();
if(checkStylesIncludedRE("/realestatemanager.css") === false ) {
    $doc->addStyleSheet( JURI::base(true) .'/components/com_realestatemanager/includes/realestatemanager.css');
}

if(checkStylesIncludedRE("/jquerOs-ui.min.css") === false ) {
    $doc->addStyleSheet(JURI::root() . "components/com_realestatemanager/includes/jquerOs-ui.min.css");
}

$jinput = JFactory::getApplication()->input;
$database = JFactory::getDBO();

// load language
require_once JPATH_BASE . '/administrator/components/com_realestatemanager/language.php';

if(!function_exists('sefRelToAbs')){
    function sefRelToAbs($value){
        //Need check!!!
        //Replace all &amp; with & as the router doesn't understand &amp;
        $url = str_replace('&amp;', '&', $value);
        if(substr(strtolower($url),0,9) != "index.php") return $url;
        $uri    = JURI::getInstance();
        $prefix = $uri->toString(array('scheme', 'host', 'port'));
        return $prefix.JRoute::_($url);
    }
}



global $mosConfig_absolute_path, $mosConfig_allowUserRegistration, $mosConfig_lang, $database, $mosConfig_live_site;
require_once('./components/com_realestatemanager/compat.joomla1.5.php');

$searchLayout = $params->get('search_result_layout');
$moduleclass_sfx=$params-> get('moduleclass_sfx');
$ItemId_tmp_from_params=$params->get ('ItemId');

$database->setQuery("SELECT id FROM #__menu WHERE link LIKE'%option=com_realestatemanager%' AND params LIKE '%back_button%'");
$ItemId_tmp_from_db = $database->loadResult();
if($ItemId_tmp_from_params=="") $ItemId=$ItemId_tmp_from_db; else $ItemId=$ItemId_tmp_from_params;


//search string
$search_val = $jinput->getRaw('searchtext') ? trim($jinput->getRaw('searchtext')) : '';
$searchtext = '<input class="inputbox" type="text" name="searchtext" value="'.$search_val.'" size="20" maxlength="20"/>';

//categories
if (isset($langContent)) {
    $lang = $langContent;
    $query = "SELECT lang_code FROM #__languages WHERE sef = '$lang'";
    $database->setQuery($query);
    $lang = $database->loadResult();
    $lang = " c.language = '$lang' or c.language like 'all' or c.language like '' "
     . " or c.language like '*' or c.language is null ";
} else {
    $lang = "";
}

$category_val = $jinput->getRaw('catid') ? trim($jinput->getRaw('catid')) : _REALESTATE_MANAGER_LABEL_ALL;
$categories[] = mosHTML :: makeOption(_REALESTATE_MANAGER_LABEL_ALL, _REALESTATE_MANAGER_LABEL_ALL);
$clist = com_house_categoryTreeList(0, '', true, $categories,  $category_val, $lang);

//select list for listing type
$listing_type_val = $jinput->getRaw('listing_type') ? trim($jinput->getRaw('listing_type')) : _REALESTATE_MANAGER_LABEL_ALL;
$listing_type[]=mosHtml::makeOption(_REALESTATE_MANAGER_LABEL_ALL,_REALESTATE_MANAGER_LABEL_ALL);
$listing_type[]=mosHtml::makeOption(3,_REALESTATE_MANAGER_OPTION_FOR_PROPERTY_REQUEST);
$listing_type[]=mosHtml::makeOption(1,_REALESTATE_MANAGER_OPTION_FOR_RENT);
$listing_type[]=mosHtml::makeOption(2,_REALESTATE_MANAGER_OPTION_FOR_SALE);
$listing_type_list = mosHTML :: selectList($listing_type, 'listing_type', 'class="inputbox modSearchSelect" size="1" style="width: 115px"', 'value', 'text', $listing_type_val);
$params->def('listing_type_list',$listing_type_list);

//select list for listing status
$listing_status_val = $jinput->getRaw('listing_status') ? trim($jinput->getRaw('listing_status')) : _REALESTATE_MANAGER_LABEL_ALL;
$listing_status[] = mosHtml::makeOption(_REALESTATE_MANAGER_LABEL_ALL,_REALESTATE_MANAGER_LABEL_ALL);
$listing_status1=explode(',',_REALESTATE_MANAGER_OPTION_LISTING_STATUS);
$i=1; foreach($listing_status1 as $listing_status2) {$listing_status[]=mosHtml::makeOption($i,$listing_status2);$i++;}
$listing_status_list = mosHTML :: selectList($listing_status, 'listing_status', 'class="inputbox modSearchSelect" size="1" style="width: 115px"', 'value', 'text', $listing_status_val);
$params->def('listing_status_list', $listing_status_list);

//price
$query = "SELECT max(price+0) FROM #__rem_houses as r ".
            " WHERE r.published = '1' and r.approved = '1'";
$database->setQuery($query);
$max_price = $database->loadResult();
//$prices = $database->loadColumn();
//rsort($prices,SORT_NUMERIC);
?>

<?php
if( !function_exists('filterDateSearchMod') ) {
    function filterDateSearchMod() {
        global $realestatemanager_configuration;
        $DateToFormat = str_replace("d", 'dd', (str_replace("m", 'mm', (str_replace("Y", 'yy', (str_replace('%', '', $realestatemanager_configuration['date_format'])))))));
        return $DateToFormat;
    }
}
?>

<?php
if(checkJavaScriptIncludedRE("/jQuerOs-2.2.4.min.js") === false ) {
  $doc->addScript(JURI::root(true) . '/components/com_realestatemanager/includes/jQuerOs-2.2.4.min.js');
}
?>

<?php
if(checkJavaScriptIncludedRE("/jquerOs-ui.min.js") === false ) {
  $doc->addScript(JURI::root(true) . '/components/com_realestatemanager/includes/jquerOs-ui.min.js');
}
?>

<?php
    //price, dates from-to
    $pricefrom_val = $jinput->getRaw('pricefrom2') ? $jinput->getRaw('pricefrom2') : 0;
    $priceto_val = $jinput->getRaw('priceto2') ? $jinput->getRaw('priceto2') : $max_price;

    $search_date_from_val =  $jinput->getRaw('search_date_from') ? $jinput->getRaw('search_date_from') : '';
    $search_date_until_val =  $jinput->getRaw('search_date_until') ? $jinput->getRaw('search_date_until') : '';

 ?>

 <noscript>Javascript is required to use <a href="https://ordasoft.com/joomla-real-estate" title="joomla real estate">Joomla Real Estate</a>, <a href="https://ordasoft.com/how-to-create-real-estate-website" title="How to create real estate website" >How to create real estate website</a></noscript>


<script>


jQuerOs(function() {
    jQuerOs( "#search_date_from_mod, #search_date_until_mod" ).datepicker(
    {
        minDate: "+0",
        dateFormat: "<?php echo filterDateSearchMod(); ?>",
    });
    jQuerOs('.ui-datepicker').addClass('notranslate'); //fix error with Google ajax(instance) translate
});
</script>
<script type="text/javascript">

       jQuerOs(function() {
            jQuerOs("#rem_slider_mod").slider({
                min: 0,
                max: <?php echo $max_price; ?>,
                values: [<?php echo $pricefrom_val; ?>,<?php echo $priceto_val; ?>],
                range: true,
                stop: function(event, ui) {
                    jQuerOs("input#pricefrom").val(jQuerOs("#rem_slider_mod").slider("values",0));
                    jQuerOs("input#priceto").val(jQuerOs("#rem_slider_mod").slider("values",1));
                },
                slide: function(event, ui){
                    jQuerOs("input#pricefrom").val(jQuerOs("#rem_slider_mod").slider("values",0));
                    jQuerOs("input#priceto").val(jQuerOs("#rem_slider_mod").slider("values",1));
                }
            });

            jQuerOs("input#pricefrom").change(function(){
                var value1=jQuerOs("input#pricefrom").val();
                var value2=jQuerOs("input#priceto").val();

                if(parseInt(value1) > parseInt(value2)){
                    value1 = value2;
                    jQuerOs("input#pricefrom").val(value1);
                }
                jQuerOs("#rem_slider_mod").slider("values",0,value1);
            });

            jQuerOs("input#priceto").change(function(){
                var value1=jQuerOs("input#pricefrom").val();
                var value2=jQuerOs("input#priceto").val();
                if(parseInt(value1) > parseInt(value2)){
                    value2 = value1;
                    jQuerOs("input#priceto").val(value2);
                }
                jQuerOs("#rem_slider_mod").slider("values",1,value2);
            });
        });
    </script>

<div class="com_realestatemanager<?php echo $moduleclass_sfx;?>">
    <div id="rem_mod_search" style="display:inline-block;">
    <form action="<?php echo sefRelToAbs("index.php?option=com_realestatemanager&amp;task=search&amp;Itemid=".$ItemId); ?>" method="get" name="mod_realestatlibsearchForm">
        <div style="display:inline-block; margin-right:10px;">

        <?php
        if(($params->get('label_search_keyword') == 0)) {
        ?>
        <div class="search_houses">
            <div class="search_title">
                <?php echo _REALESTATE_MANAGER_LABEL_SEARCH_KEYWORD; ?>
            </div>
                <?php echo $searchtext; ?>
        </div>
        <?php
        }
        if(($params->get('label_category') == 0)) {
        ?>
        <div class="col_box">
            <span><?php echo _REALESTATE_MANAGER_LABEL_CATEGORY; ?></span>
            <?php echo $clist; ?>
        </div>
        <?php
        }
        ?>

        </div>
        <?php if($params->get('label_check_in') == 0 || $params->get('label_check_out') == 0) { ?>
            <div class="search_rent" style="display:inline-block; margin-right:10px;">
                <div class="box_from" >
                    <span class="col_01"><?php echo _REALESTATE_MANAGER_LABEL_RENT_REQUEST_FROM; ?></span>
                    <input type="text" id="search_date_from_mod" name="search_date_from" value="<?php echo $search_date_from_val; ?>">
                </div>
                <div class="box_from" >
                    <span class="col_01"><?php echo _REALESTATE_MANAGER_LABEL_RENT_REQUEST_UNTIL; ?></span>
                    <input type="text" id="search_date_until_mod" name="search_date_until" value="<?php echo $search_date_until_val; ?>">
                </div>
            </div>
        <?php } if($params->get('label_price') == 0){ ?>
            <div class="col_box_1" style="display:inline-block; margin-right:10px;">
                <span class="price_label"><?php echo _REALESTATE_MANAGER_LABEL_PRICE; ?></span>
                <div id="rem_slider_mod" class="ui-slider ui-slider-horizontal ui-widget ui-widget-content ui-corner-all"></div>
                <div class="pricefrom_2">
                    <span><?php echo _REALESTATE_MANAGER_LABEL_FROM; ?></span>
                    <input type="text" id="pricefrom" name="pricefrom2"  value="<?php echo $pricefrom_val; ?>"/>
                </div>
                <div class="priceto_2">
                    <span><?php echo _REALESTATE_MANAGER_LABEL_TO; ?></span>
                    <input type="text" id="priceto" name="priceto2" value="<?php echo $priceto_val; ?>"/>
                </div>
                <div style="clear: both;"></div>
            </div>
        <?php } ?>
            <div style="display:inline-block; margin-right:10px;">
          <?php
          if($params->get('listing_type_list') == 0){?>
                    <div class="col_box_2">
                        <span><?php echo _REALESTATE_MANAGER_LABEL_LISTING_TYPE; ?></span>
                        <?php echo $listing_type_list; ?>
                    </div>
          <?php }?>
          <?php if($params->get('listing_status_list') == 0){?>
                    <div class="col_box_2">
                        <span><?php echo _REALESTATE_MANAGER_LABEL_LISTING_STATUS; ?></span>
                        <?php echo $listing_status_list; ?>
                    </div>
          <?php }?>
          </div>
<div class="search_button">
    <input type="submit" value="<?php echo _REALESTATE_MANAGER_LABEL_SEARCH_BUTTON; ?>" class="button"  >
</div>


    <input type="hidden" name="Houseid" value="on"/>
    <input type="hidden" name="Description" value="on"/>
    <input type="hidden" name="Title" value="on"/>
    <input type="hidden" name="Address" value="on" />
    <input type="hidden" name="Country" value="on" />
    <input type="hidden" name="Region" value="on" />
    <input type="hidden" name="City" value="on" />
    <input type="hidden" name="Zipcode" value="on" />
    <input type="hidden" name="ownername" value="on" />
    <input type="hidden" name="Bathrooms" value="on" />
    <input type="hidden" name="Bedrooms" value="on" />
    <input type="hidden" name="Contacts" value="on" />
    <input type="hidden" name="Agent" value="on" />
    <input type="hidden" name="Lot_size" value="on" />

    
    <input type="hidden" name="typeLayout" value="alone_category" />
    <input type="hidden" name="searchLayout" value="<?php echo $searchLayout; ?>" />
    <input type="hidden" name="option" value="com_realestatemanager" />
    <input type="hidden" name="task" value="search" />
    <input type="hidden" name="Itemid" value="<?php echo $ItemId ?>" />

</form>
</div>
</div>
<div style="text-align: center;"><a href="https://ordasoft.com/joomla-real-estate" 
    title="joomla real estate" 
 style="font-size: 10px;">Joomla Real Estate</a>, by OrdaSoft</div>
